package com.sonic.cow.enums;

import com.sonic.common.exception.BizException;
import com.sonic.common.rpc.ApiResultCode;
import com.sonic.common.utils.MessageUtils;
import lombok.Getter;

/**
 * @description: 弹窗消息的定义
 * @author: code
 * @create: 2021-12-17 10:25
 **/
@Getter
public enum BizResultCode implements ApiResultCode {


    /**
     * 生成图片超时提示
     */
    GEN_IMAGE_TIMEOUT("8006", "生成图片超时"),

    MISS_PARAM_ERROR("1001010", "Missing parameter"),

    ;


    private final String errorCode;
    private final String errorMsg;

    BizResultCode(String errorCode, String errorMsg) {
        this.errorCode = errorCode;
        this.errorMsg = errorMsg;
    }

    /**
     * 得到 message 的值.
     *
     * @return 属性 message 的值.
     */
    @Override
    public String getErrorMsg() {
        return errorMsg + "(" + getAppId() + ")";
    }

    /**
     * @return 当前服务的AppId
     */
    @Override
    public String getAppId() {
        return "1002";
    }

    /**
     * 校验方法
     *
     * @param expect
     */
    public void check(boolean expect) {
        if (expect) {
            String message = MessageUtils.get(this.name());
            throw new BizException(this.getErrorCode(), this.name().equals(message) ? this.getErrorMsg() : message);
        }
    }

    /**
     * 校验方法
     *
     * @param expect
     * @param code
     */
    public void check(boolean expect, String code) {
        if (expect) {
            String message = MessageUtils.get(this.name());
            throw new BizException(code, this.name().equals(message) ? this.getErrorMsg() : message);

        }
    }

    /**
     * 校验方法
     *
     * @param expect
     * @param code
     * @param message
     */
    public void check(boolean expect, String code, String message) {
        if (expect) {
            throw new BizException(code, message);
        }
    }
}
